--DESCRIPTION
--This script lists the definition of the specified trigger.
--
--USAGE
--        @SHOW_TRIGGER [owner.]trigger_name
--    

SET ECHO OFF
SET HEADING OFF
SET RECSEP OFF
SET NEWPAGE 1
SET VERIFY OFF
SET FEEDBACK OFF
SET PAGESIZE 0
SET LONG 10000

--Disect the input argument, and get the owner name and
--table name into two seperate substitution variables.
--The owner name defaults to the current user.
DEFINE s_owner_name = ' '
DEFINE s_trigger_name = ' '
COLUMN owner_name NOPRINT NEW_VALUE s_owner_name
COLUMN trigger_name NOPRINT NEW_VALUE s_trigger_name
SELECT
  DECODE(INSTR('&&1','.'),
         0,USER,  /*Default to current user.*/
         UPPER(SUBSTR('&&1',1,INSTR('&&1','.')-1))) owner_name,
  DECODE(INSTR('&&1','.'),
         0,UPPER('&&1'),  /*Only the table name was passed in.*/
         UPPER(SUBSTR('&&1',INSTR('&&1','.')+1))) trigger_name
  FROM dual;

--Setup the formats 
COLUMN description FORMAT A60 WORD_WRAPPED
COLUMN referencing_names FORMAT A60 WORD_WRAPPED FOLD_BEFORE
COLUMN when_clause FORMAT A60 WORD_WRAPPED FOLD_BEFORE
COLUMN trigger_body FORMAT A60 WRAPPED FOLD_BEFORE

SELECT 'TRIGGER ' || '&&s_owner_name..' || 
       RTRIM(description) description,
       RTRIM(referencing_names) referencing_names,
       'WHEN ' || when_clause when_clause,
       trigger_body
  FROM all_triggers
 WHERE owner = '&&s_owner_name'
   AND trigger_name = '&&s_trigger_name';

--Reset everything back to its default setting
TTITLE OFF
SET HEADING ON
SET RECSEP WRAPPED
SET VERIFY ON
SET FEEDBACK ON
SET PAGESIZE 24
SET LONG 80
CLEAR BREAKS
CLEAR COLUMNS

