--DESCRIPTION
--List tables owned by the current user, or owned by a specified user.
--The user is prompted for an owner name. If an owner is not specified, 
--i.e. the user just presses ENTER, then tables are listed for 
--the current user.

SET ECHO OFF
SET FEEDBACK OFF
SET VERIFY OFF
SET DEFINE ON
SET HEADING OFF
SET LINESIZE 120

--Ask the user for the owner.
ACCEPT username CHAR PROMPT 'List synonyms for user: '
PROMPT

--Setup the title to print the owner.
TTITLE LEFT 'SYNONYMS OWNED BY: ' owner SKIP 1
COLUMN owner NOPRINT NEW_VALUE owner

  --List synonyms owned by the user specified
  --Information is displayed in three lines to accomodate the 
  --longest possible values for each data element.
  COLUMN owner NOPRINT
  COLUMN synonym_name NOPRINT
  COLUMN db_link FORMAT A60 WRAPPED
  PROMPT
  SELECT owner,
         synonym_name,
         '      ' || owner || '.' || synonym_name 
         || ' synonym for ' || table_owner || '.' || table_name
         || DECODE(db_link,NULL,NULL,CHR(10) || 'at ' || db_link) syn_def
    FROM all_synonyms
   WHERE owner = DECODE('&&username',NULL,USER,UPPER('&&username'))
  ORDER BY synonym_name;

--Clean up: undefine vars, clear columns, change settings back to defaults.
UNDEFINE username
UNDEFINE owner
COLUMN owner CLEAR
TTITLE OFF
SET HEADING ON
SET FEEDBACK ON
SET VERIFY ON
SET LINESIZE 80

