SET ECHO OFF
SET PAGESIZE 50
SET LINESIZE 60
SET NEWPAGE 0
SET FEEDBACK OFF
SET TRIMSPOOL ON

TTITLE LEFT 'Product User Profile Report' -
       RIGHT 'Page ' FORMAT 9999 SQL.PNO SKIP 6
BTITLE OFF
 
COLUMN userid FORMAT A12 HEADING 'User'
COLUMN sort_by NOPRINT 
COLUMN command FORMAT A15 HEADING 'Disabled|Commands'
COLUMN role FORMAT A30 HEADING 'Disabled|Roles'

BREAK ON userid SKIP 1

PROMPT You are about to generate a product user profile report.
ACCEPT PUP_REPORT_FILE -
       PROMPT 'Enter the filename for the report output: ' -
       DEFAULT 'PUP_REPORT.LIS'

SPOOL &&PUP_REPORT_FILE
SET TERMOUT OFF

SELECT userid, 1 sort_by, attribute command, '' role
  FROM product_profile
 WHERE product = 'SQL*Plus'
   AND attribute <> 'ROLES'
   AND char_value = 'DISABLED'
UNION
SELECT userid, 2 sort_by, '' command, char_value role 
  FROM product_profile
 WHERE product = 'SQL*Plus'
   AND attribute = 'ROLES'
ORDER BY userid, sort_by, command, role
;

SPOOL OFF
SET TERMOUT ON

--Restore these settings to their defaults
TTITLE OFF
CLEAR COLUMNS
SET PAGESIZE 14
SET LINESIZE 80
SET NEWPAGE 1
SET FEEDBACK ON
SET TRIMSPOOL OFF

